package com.sun.media.sound;

import java.util.Arrays;

public final class ModelConnectionBlock
{
    private static final ModelSource[] no_sources;
    private ModelSource[] sources;
    private double scale;
    private ModelDestination destination;
    
    public ModelConnectionBlock() {
        this.sources = ModelConnectionBlock.no_sources;
        this.scale = 1.0;
    }
    
    public ModelConnectionBlock(double scale, ModelDestination destination) {
        this.sources = ModelConnectionBlock.no_sources;
        this.scale = 1.0;
        this.scale = scale;
        this.destination = destination;
    }
    
    public ModelConnectionBlock(ModelSource modelSource, ModelDestination destination) {
        this.sources = ModelConnectionBlock.no_sources;
        this.scale = 1.0;
        if (modelSource != null) {
            (this.sources = new ModelSource[1])[0] = modelSource;
        }
        this.destination = destination;
    }
    
    public ModelConnectionBlock(ModelSource modelSource, double scale, ModelDestination destination) {
        this.sources = ModelConnectionBlock.no_sources;
        this.scale = 1.0;
        if (modelSource != null) {
            (this.sources = new ModelSource[1])[0] = modelSource;
        }
        this.scale = scale;
        this.destination = destination;
    }
    
    public ModelConnectionBlock(ModelSource modelSource, ModelSource modelSource2, ModelDestination destination) {
        this.sources = ModelConnectionBlock.no_sources;
        this.scale = 1.0;
        if (modelSource != null) {
            if (modelSource2 == null) {
                (this.sources = new ModelSource[1])[0] = modelSource;
            }
            else {
                (this.sources = new ModelSource[2])[0] = modelSource;
                this.sources[1] = modelSource2;
            }
        }
        this.destination = destination;
    }
    
    public ModelConnectionBlock(ModelSource modelSource, ModelSource modelSource2, double scale, ModelDestination destination) {
        this.sources = ModelConnectionBlock.no_sources;
        this.scale = 1.0;
        if (modelSource != null) {
            if (modelSource2 == null) {
                (this.sources = new ModelSource[1])[0] = modelSource;
            }
            else {
                (this.sources = new ModelSource[2])[0] = modelSource;
                this.sources[1] = modelSource2;
            }
        }
        this.scale = scale;
        this.destination = destination;
    }
    
    public ModelDestination getDestination() {
        return this.destination;
    }
    
    public void setDestination(ModelDestination destination) {
        this.destination = destination;
    }
    
    public double getScale() {
        return this.scale;
    }
    
    public void setScale(double scale) {
        this.scale = scale;
    }
    
    public ModelSource[] getSources() {
        return (ModelSource[])Arrays.copyOf(this.sources, this.sources.length);
    }
    
    public void setSources(ModelSource[] original) {
        this.sources = ((original == null) ? ModelConnectionBlock.no_sources : ((ModelSource[])Arrays.copyOf(original, original.length)));
    }
    
    public void addSource(ModelSource modelSource) {
        ModelSource[] sources = this.sources;
        System.arraycopy(sources, 0, this.sources = new ModelSource[sources.length + 1], 0, sources.length);
        this.sources[this.sources.length - 1] = modelSource;
    }
    
    static {
        no_sources = new ModelSource[0];
    }
}
